function Est41000_ajuste_inventario(DecodeValueFieldService) {
    function addThousandSeparators(value) {
        value += '';
        var x = value.split(',');
        var x1 = x[0];
        var x2 = x.length > 1 ? ',' + x[1] : '';
        var rgx = /(\d+)(\d{3})/;
        while (rgx.test(x1)) {
            x1 = x1.replace(rgx, '$1.$2');
        }

        return x1 + x2;
    }

    function decodeTextViewFloat(field, fieldRow) {
    	if(typeof fieldRow === 'string'){
            fieldRow = fieldRow.replace(/\./g, '');
            fieldRow = fieldRow.replace(',', '.');
    	}
        var viewRow = parseFloat(fieldRow);
    	viewRow = isNaN(viewRow) ? "" : viewRow.toFixed(3).replace('.', ',');
        return addThousandSeparators(viewRow);
    }

    DecodeValueFieldService.register('text-edit-view-float.html', decodeTextViewFloat);
}

Configuration(function(ContextRegister){
    ContextRegister.register('Est41000_ajuste_inventario', Est41000_ajuste_inventario);
});