var Est57000_TransferenciaEstoque_Service = function (General,Est57000_TransferenciaEstoque_Repository,ZHPromise,ScreenService) {

    this.buscaDataProcessamento = function(row){
        return Est57000_TransferenciaEstoque_Repository.buscaDataProcessamento(row);
    };

    this.salvarNovaTransferencia = function(rows){
        return Est57000_TransferenciaEstoque_Repository.saveNovaTransferencia(rows);
    };

    this.salvarNovoProdutoTransferencia = function(row){
        return Est57000_TransferenciaEstoque_Repository.saveNovoProdutoTransferencia(row);
    };

    this.salvarNovaTransferenciaComRequisicao = function(row){
        return Est57000_TransferenciaEstoque_Repository.saveNovaTransferenciaComRequisicao(row);
    };

    this.editarProduto = function(row){
        return Est57000_TransferenciaEstoque_Repository.editProduto(row);
    };

    this.deletarProduto = function(row){
        return Est57000_TransferenciaEstoque_Repository.deleteProduto(row);
    };

    this.deletarTransferencia = function(row){
        return Est57000_TransferenciaEstoque_Repository.deleteTransferencia(row);
    };
    
    this.getAlmoxRequisicao = function(row) {
        return Est57000_TransferenciaEstoque_Repository.getAlmoxRequisicao(row);  
    };

    this.verificaEstoqueProduto = function(row) {
        return Est57000_TransferenciaEstoque_Repository.verificaEstoqueProduto(row);  
    };
    
    this.buscaProdutosRequisicao = function(row) {
        return Est57000_TransferenciaEstoque_Repository.buscaProdutosRequisicao(row);  
    };
    
    this.setVrTotLancto = function(rowItem) {
    	rowItem.VRTOTLANCTO = rowItem.QTTOTLANCTO * rowItem.VRUNILANCTO;
    };
    
    this.checaItensDaRetirada = function(data, cdarvprod, cdalmoxarife, cdlocalestoq, nrloteestq, nrsublote) {
		var contem = false;
		data.splice(data.length -1, 1);
	
    	data.forEach(function(item){
			 if(item.CDARVPROD === cdarvprod) {
			 	contem = true;
			 }
		});
		
		return contem;
	};

    this.getParamFilial = function(){
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est_relatorios#/crud/filial_paramfilial_tipocusto', 'FilterData', filter);
    };

    this.importarProdutosTxt = function(row){
    	return Est57000_TransferenciaEstoque_Repository.importarProdutosTxt(row);
    };
    
    this.geraNrsequitem= function(itens) {
		var nrsequitemArray=[0];
		itens.forEach(function(item) {
		    if(item.NRSEQUITEM)
			    nrsequitemArray.push(item.NRSEQUITEM);
		});
		return ('000'+(Math.max.apply(this,nrsequitemArray)+1)).slice(-4);
	};
	
	this.getCdtipocusto = function(cdfilial) {
		return Est57000_TransferenciaEstoque_Repository.getCdtipocusto(cdfilial).then(function(callback){
			return callback.dataset.paramfilial[0].CDTIPCUSTEST;
		});
	};
	
	this.setBlankLocalEstFields = function(widget){
		if(!widget.currentRow.hasOwnProperty('CDALMOXARIFE')){
			widget.currentRow.CDALMOXARIFE = ' ';
		}
		if(!widget.currentRow.hasOwnProperty('CDLOCALESTOQ')){
			widget.currentRow.CDLOCALESTOQ = ' ';
		}
		
		if(!widget.currentRow.hasOwnProperty('NRLOTEESTQ')){
			widget.currentRow.NRLOTEESTQ = ' ';
		}
		
		if(!widget.currentRow.hasOwnProperty('NRSUBLOTE')){
			widget.currentRow.NRSUBLOTE = ' ';
		} 

	};
};

Configuration(function(ContextRegister){
    ContextRegister.register('Est57000_TransferenciaEstoque_Service', Est57000_TransferenciaEstoque_Service);
});