var Ger03301_RelatorioInventarioRotativo_Controller = function(ScreenService, Ger03301_RelatorioInventarioRotativo_Repository, Unidade_Repository, ZhFilterPreferences, templateManager) {
    var readOnlyLocalizacao;
    var cdfilial;
    var dtprocessa;
    var cdalmoxarifado;
    var cdlocalizacao;

    this.setCdfilialAndReadOnly = function(widget) {
       /* Unidade_Repository.retornaUnidadeLogada().then(function(sucess){
            cdfilial = sucess[0].CDFILIAL;
            widget.getField('REPORT_NAME').setValue('CD'); // DEFAULTVALUE não estava funcionando para select-ntive, se estiver funcionando, essa linha pode ser apagada
            var data = [{
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdfilial
            }];
            Ger03301_RelatorioInventarioRotativo_Repository.paramFilial(data).then(function(sucess){
                dtprocessa = moment(sucess[0].DTPROCESSA, "DD/MM/YYYY").format("DD/MM/YYYY");
                if(sucess[0].IDUTILALMOX == 'S'){
                    var field = widget.getField('DSALMOXARIFE');
                    field.readOnly = false;
                    field.dataSourceFilter[0].value = cdfilial;
                    field.filterProperties.validations.required = true;
                    if(sucess[0].IDUTILLCESTQ == 'S'){
                        field = widget.getField('DSLOCALESTOQ');
                        field.readOnly = false;
                        readOnlyLocalizacao = false;
                        field.dataSourceFilter[2].value = cdfilial;
                        field.filterProperties.validations.required = true;
                    } else {
                        readOnlyLocalizacao = true;
                    }
                }
            });
        }); */
    };

    this.setDataSourceAndReadOnly = function(widget){
        cdalmoxarifado = widget.currentRow.CDALMOXARIFE;
        if(!readOnlyLocalizacao){
            var field = widget.getField('DSLOCALESTOQ');
            field.readOnly = false;
            field.dataSourceFilter[2].value = cdalmoxarifado;
        }
    };

    this.buildDataSourceFilter = function(widget){
        var widgetPopupFilter = widget.appliedFilter.FILTER_ROW;
        var filtro = [
            {
                "name": "PARAM",
                "operator": "=",
                "value": widgetPopupFilter.REPORT_NAME
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": cdfilial
            },
            {
                "name": "P_DTPROCESSA",
                "operator": "=",
                "value": dtprocessa
            },
            {
                "name": "P_CDALMOXARIFE",
                "operator": "=",
                "value": widgetPopupFilter.CDALMOXARIFE||" "
            },
            {
                "name": "P_CDLOCALESTOQ",
                "operator": "=",
                "value": widgetPopupFilter.CDLOCALESTOQ||" "
            }
        ];
        widget.dataSourceFilter = filtro;
    };

    this.setCdlocalizacao = function(fieldValue){
        cdlocalizacao = fieldValue;
    };

    this.buildDatSetForReport = function(widget){
        var dataSet = widget.dataSource.data;
        let codAlmox = ' ';//dataSet[0].CDALMOXARIFE;
        let dsAlmox = '';
        let codLocal = ' ';//dataSet[0].CDLOCALESTOQ;
        let dsLocal = '';
        
        var rowLocais = {
                            "NMPRODUTO": codAlmox+' - '+dsAlmox,
                            "NRLOTEESTQ": codLocal+' - '+dsLocal
                        }; 
        //dataSet.splice(0, 0, rowLocais);
        for (var i = 0; i < dataSet.length; i++) {
            if(( dataSet[i].CDALMOXARIFE != codAlmox) || (dataSet[i].CDLOCALESTOQ != codLocal )) {
                codAlmox = dataSet[i].CDALMOXARIFE;
                dsAlmox = dataSet[i].DSALMOXARIFE != ' '? ' - '+dataSet[i].DSALMOXARIFE : '';
                codLocal = dataSet[i].CDLOCALESTOQ;
                dsLocal = dataSet[i].DSLOCALESTOQ != ' '? ' - '+dataSet[i].DSLOCALESTOQ : '';
                
                rowLocais = {
                                "NMPRODUTO": codAlmox + dsAlmox,
                                "NRLOTEESTQ": codLocal + dsLocal
                            }; 
                dataSet.splice(i, 0, rowLocais);
            } else {
                dataSet[i].SALDO = "_____________";
                if(dataSet[i].DTVALILOTE){
                    dataSet[i].DTVALILOTE = moment(widget.dataSource.data[i].DTVALILOTE, "DD/MM/YYYY").format("DD/MM/YYYY");
                }
            }
            
        }
        widget.dataSource.data = dataSet;
    };
    
    this.changeFilterFilial = function(cdfilial){
        var data = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": cdfilial
        }];
        return Ger03301_RelatorioInventarioRotativo_Repository.paramFilial(data).then((sucess) => {
            let widgetFiltro = templateManager.container.getActiveWidget();
            dtprocessa = moment(sucess[0].DTPROCESSA, "DD/MM/YYYY").format("DD/MM/YYYY");
            if(sucess[0].IDUTILALMOX == 'S'){
                var field = widgetFiltro.getField('DSALMOXARIFE');
                field.readOnly = false;
                //field.validations.required = true;  remover required dos campos de almox pois existem nvl na query
                if(sucess[0].IDUTILLCESTQ == 'S'){
                    field = widgetFiltro.getField('DSLOCALESTOQ');
                    field.readOnly = false;
                    readOnlyLocalizacao = false;
                    //field.validations.required = true;  remover required dos campos de almox pois existem nvl na query
                } else {
                    readOnlyLocalizacao = true;
                }
            }
        });
    };
    
    this.startFilter = function(widget) {
        var filterRow = {};
        Unidade_Repository.retornaUnidadeLogada().then((sucess) => {
            filterRow = sucess[0];
            filterRow.REPORT_NAME = 'CD';
            widget.getField('REPORT_NAME').setValue('CD'); // DEFAULTVALUE não estava funcionando para select-ntive, se estiver funcionando, essa linha pode ser apagada
            ZhFilterPreferences.openFilterWidget(widget, filterRow).then(opened => {
                 this.changeFilterFilial(filterRow.CDFILIAL);
            });
        });
    };
    
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger03301_RelatorioInventarioRotativo_Controller', Ger03301_RelatorioInventarioRotativo_Controller);
});