var Ger28000_TipoRetirada_Controller = function(General, templateManager, ZhFilterPreferences) {

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var defaultFilter = widget.dataSourceFilter;
        ZhFilterPreferences.setOriginalFilter(widget.id, defaultFilter);
        ZhFilterPreferences.openFilterWidget(widget, defaultFilter);
    };
    
    
    this.setFieldsGerais = function(widget){
        templateManager.container.fieldsGerais = widget.fields.map(function(field){return field.name;});
    };

	this.save = function(widget) {
	    if(widget.isValid()){
	        widget.currentRow.CDTIPORETI = widget.getParent().currentRow.CDTIPORETI;
            General.saveCrud(widget);
	    }
    };

    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };
    
    this.salvarTipoRetirada = function(widget){
        if(widget.isValid()){
            General.saveCrud(widget);
            this.controlaStatusWidgets(widget,'tipo_de_retirada', true); 
        }
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger28000_TipoRetirada_Controller', Ger28000_TipoRetirada_Controller);
});