var Est33000_RequisicaoEstoque_Repository = function (restEngine) {

    this.saveRequisicaoProdutos = function(rows) {
        return restEngine.post('est#/saveNovaRequisicaoProdutos', {
            "requestType": "Row",
            "row": rows
        });
    };

    this.saveNovoProduto = function(row) {
        return restEngine.post('est#/saveNovoProduto', {
            "requestType": "Row",
            "row": row
        });
    };

    this.deleteProduto = function(row) {
        return restEngine.post('est#/deleteProdutoRequisicao', {
            "requestType": "Row",
            "row": row
        });
    };

    this.deleteRequisicao = function(row) {
        return restEngine.post('est#/deleteRequisicao', {
            "requestType": "Row",
            "row": row
        });
    };


};

Configuration(function(ContextRegister){
    ContextRegister.register('Est33000_RequisicaoEstoque_Repository', Est33000_RequisicaoEstoque_Repository);
});