Configuration(function(RepositoryFactory, ContextRegister, Query) {

	var ParamgeralRepository = RepositoryFactory.factory('est#/crud/paramgeral', 'LOCAL', 1, 30000);

	ParamgeralRepository.getParamgeral = function(nrorg) {
		return this.download(Query.build()
			.where('nrorg').equals(nrorg)
		);
	};

	ContextRegister.register('ParamgeralRepository', ParamgeralRepository);

});