var Est33000_RequisicaoEstoque_Service = function (General, Est33000_RequisicaoEstoque_Repository) {
    
    var dtprocessa;
    var idctrlestq;
    var idutilalmox;

    this.salvarRequisicaoProdutos = function(rows){
        return Est33000_RequisicaoEstoque_Repository.saveRequisicaoProdutos(rows);
    };

    this.salvarnovoProduto = function(row){
        return Est33000_RequisicaoEstoque_Repository.saveNovoProduto(row);
    };

	this.deletarProduto = function(row){
        return Est33000_RequisicaoEstoque_Repository.deleteProduto(row);
    };

    this.deletarRequisicao = function(row){
        return Est33000_RequisicaoEstoque_Repository.deleteRequisicao(row);
    };
    
    this.getParamFilial = function(fililal){
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": fililal
                }
		    ];
        return General.callRestEngine('est#/paramfilial_paramvalidacoes', 'FilterData', filter);
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('Est33000_RequisicaoEstoque_Service', Est33000_RequisicaoEstoque_Service);
});