var Lib00207_PosicaoEstoque_Service = function(General) {
    
    this.getDtprocessa = function(cdFilialOpcional) {
        var cdFilialFiltrada = cdFilialOpcional || "FILIAL_LOGADA";
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdFilialFiltrada
            }
        ];
        return restEngine.post("df#/crud/paramestoque_processamento", {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.getParamFilial = function(cdFilialOpcional) {
        var cdFilialFiltrada = cdFilialOpcional || "FILIAL_LOGADA";
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdFilialFiltrada
            }
        ];
        return restEngine.post("df#/crud/paramfilial", {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
    this.getPosicaoDeEstoquePorProduto = function(row) {
	    var filter = [
	    	{
	    		"name": "CDPRODUTO",
				"operator": "=",
				"value": row.CDPRODUTO
			},
			{
	    		"name": "CDFILIAL",
				"operator": "=",
				"value": row.CDFILIAL
			},
			{
	    		"name": "CDALMOXARIFE",
				"operator": "=",
				"value": row.CDALMOXARIFE
			},
			{
	    		"name": "CDLOCALESTOQ",
				"operator": "=",
				"value": row.CDLOCALESTOQ
			},
			{
	    		"name": "NRLOTEESTQ",
				"operator": "=",
				"value": row.NRLOTEESTQ
			},
			{
	    		"name": "NRSUBLOTE",
				"operator": "=",
				"value": row.NRSUBLOTE
			}
		];

        return General.callRestEngine('est_lancamentos#/retirada_posestdia', 'FilterData', filter).then(function(success){
            return success.dataset.posestdia[0];
        });
	
	};
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Lib00207_PosicaoEstoque_Service', Lib00207_PosicaoEstoque_Service);
});